# チームpreta774（向日葵研究サークル） AI概要説明
## 実行手順
1 端末を起動
2 clientstarter.py -h localhost -p 10000 と入力する

## コンセプト
豊富な短期人狼の知識を活用し、単純でそれなりの精度が稼げる推理と優れた戦術で優位を作る

# 基本戦略
## 村人
饂飩さんの発言スタイルに合わせた
（投票→3狼を挙げる→確定占いと霊能が居るなら発言する→投票先が変わったなら伝える）

## 人狼
身内切り（1日目相方人狼に人狼判定→2日目もう一人の相方人狼に村人判定）をする

## 役職
狩人:未作成
占い霊能:素直にCOする

# アルゴリズム

## 人狼推定アルゴリズム
エージェントごとに推理用のテーブルを個別に作成

朝一推理
1. 1日目、2日目限定で0票貰いのプレイヤーを狼補正
2. 噛み先の投票先を狼補正

投票時推理
1. 自分を100%村人判定にする
2. 全ての役職のデータを内訳に合わせる
（占い3人居る場合、占い師に狂人と人狼が混ざってると考え、真狂狼=1:1:1の計算にする
3. 信頼出来る霊能結果を入手する
（霊能1人、若しくは2人以上の結果が一致）
4. 占いの破綻チェックをする
（占いが人狼判定を出した箇所が、霊能結果村人判定出ているかどうか）
5. 占い先から占い師の推理をする
（人間判定出したターゲットが狼寄りの傾向の場合、その占い師を偽寄りで考慮する）
6. 占いの占い先の影響を与える
（人間判定をその占い師の真度の分村寄りにし、人狼判定をその占い師の真度の分人狼寄りにする）
7. 投票先推理をする
（狼の投票者、非投票者を村人寄りにする）
（今回の実装では、範囲を曖昧にしエージェントごとの狼度で計算をした）

## 投票アルゴリズム
最も人外率の高いプレイヤーを処刑
5-占い数の場合、占い師も投票範囲に含む
霊能は2人以上居たら優先で処刑対象

## 発言アルゴリズム
投票→3狼を挙げる→確定占いと霊能が居るなら発言する→投票先が変わったなら伝える
占い系役職の場合は3狼挙げのアルゴリズムが無い

## 囁きアルゴリズム
襲撃先を大声で叫び、他の狼が合わせる事を祈る

# 今回のアルゴリズムの問題点
 * 発言からの説得が全く出来ていない
    * 説得する仕様も、される仕様も全く無いプロコトルの仕様上ほぼ不可能
        * 説得されるアルゴリズムは非常に難解。他のエージェントの考え方（=アルゴリズム）を学習し、しかも検討する必要性がある為
 * ほぼ投票推理に依存している
    * 相方への投票を恐れない狼の動きが流行った場合、大幅に弱体化する
    * 今回は相方に投票するエージェントが多い為、推理精度が大幅に低下している
 * 戦術面での優位をつけるプランが完全に失敗している
    * 占いの吊り順の計算などのセオリーがまだ出来上がっていない
    * （初日人狼判定を出す占いが居たら、まず人狼判定されたプレイヤーを処刑し、次にその占いを処刑するという流れが一般的なのだが、それがまだ出来上がっていない）
 * 襲撃先と処刑先が干渉したり、（狼の場合）襲撃したプレイヤーの名前がプロコトルの問題で取得出来ない
    
## 問題点の解決方法
 * 説得の仕様の構築
 * 推理パターンの追加
 * 戦術面での優位は検討し直す

# 向日葵研究サークルの紹介
http://classhimawari.blogspot.jp/
当研究サークルでは、人狼知能に関する以下の研究を（検討含め）進めてるが、研究費の枯竭の為遅れが生じている

 * AIでの性格分析の研究（検討中）
    * 用途
        * 発言での推理に性格の情報を用いる事により、より推理精度を上げられる
        * 個性のある性格を作れる
        * 応用し、適当な文章からの性格分析も可能になる
 
 * Unityでのゲーム開発
    * 用途
        * 人狼知能エージェントのシステムを他ゲームにも流用可能になる

 * Node.jsでのウェブサイト開発
    * 用途
        * 枯竭している研究費の補充
 