# -*- coding: utf-8 -*-
import re
import copy
from pprint import pprint

num = re.compile("[0-9]+")
human = re.compile("HUMAN")

r_seer = re.compile("SEER")  # 重要な村役職
r_medium = re.compile("MEDIUM")  # 重要な村役職
wolf_role = re.compile("(WEREWOLF|POSSESSED)")  # 狼役職
r_comingout = re.compile("^COMINGOUT")
#other_role = ""  # その他

seer_start = {u"HUMAN": 1.0, u"POSSESSED": 1.0, u"WEREWOLF": 1.0}
medium_start = {u"HUMAN": 1.0, u"POSSESSED": 1.0, u"WEREWOLF": 1.0}
possessed_start = {u"HUMAN": 0.0, u"POSSESSED": 1.0, u"WEREWOLF": 1.0}
cco_start = {u"HUMAN": 0.1, u"POSSESSED": 0.1, u"WEREWOLF": 0.8}


# デバッグ用
def p(text):
    pass


# 非役職エージェントを処刑優先度順にソートする
def infer_sort_vill(player, alive):
    pass
    # self.player_table  self.alive_player
    # 生存者で、なおかつ村人のプレイヤーだけ取得する
"""
    # それにしてもPythonにあるまじき悪文よ
    vill_player = [
                       (v, k[u"VILLAGER"] / k[u"WEREWOLF"])
                       for v, k in player.items()
                       if k[u'assamed_role'] == "VILLAGER" and v in alive
                  ].sort(key=lambda x: x[1])

    return vill_player
"""
# {1:{'x':1}, 2:{'x':2}, 3{'x';1}}
# x = [k['x']/v for v, k in x.items()]
# x = [1, 1, 0]





# VOTE等の対象キャラのIDを入手する。プロコトルに数字が交じるアクシデントがあれば使えなくなる
def number_get(mes):
    return num.search(mes).group().lstrip("0")  # strで返す


"""
役職の取得
使い分け方法

role_player tableから参照したくない場合
role_player_id tableから参照する場合
"""


def role_player(table, get_role):  # 指定した役職のプレイヤーのデータを全員取得する（IDを考慮しない場合）
    return [k for v,k in table.items() if k[u"assamed_role"] == get_role]  # カウントしたら足す単純な作業


def role_player_id(table, get_role):  # 指定した役職のプレイヤーのIDを返す
    return [v for v,k in table.items() if k[u"assamed_role"] == get_role]  # カウントしたら足す単純な作業


def role_sum(table, get_role):  # 指定された役職の合計値を入手する
    return sum([1 for v,k in table.items() if k[u"assamed_role"] == get_role])  # カウントしたら足す単純な作業


def role_result(result_list, day):  # その日の役職の結果を入手する 　結果リスト　日にち
    l = [v for v in reversed(result_list) if v[0] == day]
    if len(l) == 0:
        return None
    else:
        return l[0]

    #for v in reversed(result_list):  # 結果が複数ある場合、もっとも最近のデータを入手する
    #    if v[0] == day:  # day, target, resultの順番で保存されているので、0を指定すれば結果の日時に合わせられる
    #        return v
    #return None  # 入手出来なかった場合


def sum_seer_medium(t):  # 役職の合計値をタプルで入手する(占い, 霊能)
    # t 拡張テーブル
    v = (role_sum(t, "SEER"), role_sum(t, "MEDIUM"))
    return v


def get_vote_target(table):  # 予定投票先をタプルのリスト化して、返す　形:[(対象ユーザー,投票数),()]
    # 投票データを取得する

    return None
    # get_vote_target(table)


def alt(i, value, coefficient=1.0):  # 推理値を指定されたテーブル通りに修正する
    # infer 拡張テーブルのエージェントオブジェクトの"infer_role"
    # value 値
    # coefficient 係数（その結果が正しい確率）（標準値は1.0）
    infer = copy.deepcopy(i)
    for v in value:
        #   v[0] * coefficient
        infer[v[1]] *= 1.0 - coefficient * (1.0 - v[0])  # 逆数して掛け算して戻す事で、減算処理でのエラーの発生を防いでいる

    return infer


def except_table(alive, except_list):  # 生存者リストを渡されたリストで消す
    return [alive.remove(v) for v in except_list if v in alive]


def except_seer_target(chara):  # 指定されたプレイヤーの占い先リストを返す
    # chara 占い師のオブジェクト情報（複数指定可）

    seer_target_list = []
    for v in chara:
        if v[u"result"]:
            [seer_target_list.append(t[1]) for t in v[u"result"]]
    return seer_target_list  # [[t[1] for t in v[u"result"]] for v in chara if v[u"result"]]


def get_seer_wolf(table):  # 占い結果●のプレイヤーの情報を返す
    # table 拡張テーブル

    seer = role_player(table, u"SEER")
    seer_target_list = []
    for v in seer:
        if v[u"result"]:
            [seer_target_list.append(t[1]) for t in v[u"result"] if t[2] == u"WEREWOLF"]
    return seer_target_list


def except_table_seer_target(chara, alive):  # 生存者テーブルの中から占われているプレイヤーを除外
    return except_table(alive, except_seer_target(chara))


def except_role(table, alive):  # 指定されたテーブルから役職を全員除外する
    seer = role_player_id(table, u"SEER")
    medium = role_player_id(table, u"MEDIUM")
    pos = role_player_id(table, u"POSSESSED")
    cco_seer = role_player_id(table, u"CCO_SEER")
    cco_medium = role_player_id(table, u"CCO_MEDIUM")
    role_list = seer + medium + pos + cco_seer + cco_medium
    if len(role_list) == 0:
        return alive

    return except_table(alive, role_list)


def infertable_sort(tuple_infer):  # 推理テーブルのタプル化データ(id, value)をソートする
    return sorted(tuple_infer, key=lambda x: x[1])


def except_none(l):
    return [v for v in l if v is not None]


def cal(i):  # 推理値を計算する i == infer_role
    if (i[u"HUMAN"] + i[u"WEREWOLF"] + i[u"POSSESSED"]) == 0.0:
        return 0.0
    return (i[u"WEREWOLF"] + i[u"POSSESSED"]) / (i[u"HUMAN"] + i[u"WEREWOLF"] + i[u"POSSESSED"])


def cal_w(i):  # 狼率を計算する i == infer_role
    if (i[u"HUMAN"] + i[u"WEREWOLF"] + i[u"POSSESSED"]) == 0.0:
        return 0.0
    return i[u"WEREWOLF"] / (i[u"HUMAN"] + i[u"WEREWOLF"] + i[u"POSSESSED"])


# 発言データからCOや投票などの重要な情報を抜き出し、テーブルに挿入し返す
def detection(table, talk):

    def seer_set():
        if agent_id in wolf_list:
            agent[u"assamed_role"] = u"CCO_SEER"
            agent[u"infer_role"] = cco_start
        else:
            agent[u"assamed_role"] = u"SEER"
            agent[u"infer_role"] = seer_start

    def medium_set():
        if agent_id in wolf_list:
            agent[u"assamed_role"] = u"CCO_MEDIUM"
            agent[u"infer_role"] = cco_start
        else:
            agent[u"assamed_role"] = u"MEDIUM"
            agent[u"infer_role"] = medium_start

    def possessed_set():
        agent[u"assamed_role"] = u"POSSESSED"
        agent[u"infer_role"] = possessed_start

    if not talk:
        return table

    wolf_list = get_seer_wolf(table)  # 狼プレイヤーを取得

    for v in talk:
        day = v[u"day"]
        agent_id = str(v[u"agent"])  # エージェントID
        agent = table[agent_id]

        content = v[u"content"]

        if re.match(r"^VOTE", content):  # 投票を確認した場合
            agent[u"today_vote"] = number_get(content)

        elif r_comingout.search(content):  # COを確認した場合
            if number_get(content) == agent_id:  # 自分のCOならチェックする。その他ならスルー
                if r_seer.search(content):  # 占いCO
                    if agent[u"assamed_role"] != u"SEER": # 初CO時の初期定義
                        seer_set()

                elif r_medium.search(content):  # 霊能CO
                    if agent[u"assamed_role"] != u"MEDIUM":  # 初CO時の初期定義
                        medium_set()

                elif wolf_role.search(content):  # 人外CO
                    possessed_set()  # とりあえず狂人判定しとく

        elif re.match(r"^DIVINED", content):  # 占い結果を張っている場合
            # 初CO時の初期定義
            if agent[u"assamed_role"] != u"SEER" and agent[u"assamed_role"] != u"CCO_SEER":  # 占いかCCO占いじゃないなら
                if agent[u"assamed_role"] == u"VILLAGER":  # まだCOしていないなら役職COとして処理する
                    seer_set()
                else:  # 既にCOしていた場合は狂人として処理
                    possessed_set()

            target_role = u"HUMAN" if human.search(content) else u"WEREWOLF"
            agent[u"result"].append((day, number_get(content), target_role))

        elif re.match(r"^INQUESTED", content):  # 霊能結果を張っている場合
            if agent[u"assamed_role"] != u"MEDIUM" and agent[u"assamed_role"] != u"CCO_MEDIUM":  # 初CO時の初期定義
                if agent[u"assamed_role"] == u"VILLAGER":  # まだCOしていないなら役職COとして処理する
                    medium_set()
                else:  # 既にCOしていた場合は狂人として処理
                    possessed_set()

            target_role = u"HUMAN" if human.search(content) else u"WEREWOLF"
            agent[u"result"].append((day, number_get(content), target_role))

    return table

