"""
拡張ID
占い/霊能結果(day, number_get(content), target_role)

作戦
短期人狼、人狼知能の仕様、及び対戦相手の傾向を分析し、最も効果的だと判断した戦術を採用する

短期人狼の基本
・占い師・霊能者の内訳（役職COしている数）によって内訳が決まる
例:3-1の場合は占い師は真・狂人・人狼　霊能は真の可能性が最も高くなる
理由:
まず真占いと霊能が素直にCOしていると仮定する
占いには、真が居ると仮定すると人外（狼・狂人）が2人混じってる計算になる
その場合、狼が2人占いに出る確率よりも、狂人と人狼が出る確率の方が高い。
狂人は役職を騙る事が多く、また狼が2人騙りに出るのはリスクが高く、あまり行われる手ではない
また、霊能は1人しか居ない為、基本的に真と仮定する


人狼知能の仕様分析
1　推理が投票及び誘導先・噛み・プレイヤーの発言傾向からの分析　等が使える可能性がある
投票及び誘導先:誘導先は信頼度がそこまで高そうにない。投票先推理（主に狼票=村推理）は確率そこまで高くはないが参考にはなる
噛み:仕様の問題で、狼3人のランダム噛みの為、方向性が見難い。噛まれた役職の投票先が参考になる位か
発言傾向:100戦ごとにIDが振り割られる為、ほぼ無意味

2　発言がほぼ無意味
今のところ役職結果貼りと票合わせ位にしか使えない

3　基本的にルールベース
つまり奇襲が何度でも成立するということでもある

総評　役職以外で発言する必要性がなく、奇襲が強い
→結果貼り以外の発言はしない、人外時は奇襲を多用


対戦相手の傾向

投票及び誘導先推理がメイン
=投票元の役職が判明しないと推理出来ない
=霊能の価値が高い
=霊能護衛又は噛みが強い

身内切りを考慮しているエージェントが少ない
=身内切りが強い

狂人→霊能●凸は内訳見られるプレイヤーが居たら弱い
=つまり人狼経験があるプレイヤーが多いと弱くなる
=厳しそうなら占い●凸　それも厳しいなら手が少ない

占い・霊能に手は無さそう
=素直にCOして後は狩人に祈るだけ
占いと霊能が最もリアル人狼に近い塩梅なのが腹立たしい

村人
吊られなければ問題ない
自分が吊られる=確定村を一人無駄に吊る事になる=不利になる
"""
"""
必要なもの

推理アルゴリズム
生存情報などをself.player_tableで管理
占い先テーブル（偽判定してない占いの○先は吊りリストから暫定的に除外する）
霊能結果テーブル
・霊1及び霊結果同じの場合は記録する。その他の場合はNone扱いする
投票推理
投票先の決定アルゴリズム
・最多被投票者を取得する
・狼率の低いプレイヤーしか居なかった場合
・・自分も最多被投票者に含まれる場合、投票する
・・含まれない場合、次点の投票者を取得する
・ターゲット（優先）か狼率の低くないプレイヤー順に投票する
予定
占い+霊能=5以上の時、占いは1人でなければ全員殺す
占いは偽率8割超えでターゲットに入れる予定
定義
・狼率の低いプレイヤー=デフォルトの5割の狼率（個別村率/個別狼率=0.5以下の時）
・ターゲット
・・複数居る霊能
・・破綻した占い師
・・狼率デフォルト超え（個別村率/個別狼率=1より上の時）

吊り対象アルゴリズム
人外率が7割超えた占い師>複数居る霊能>狼率デフォルト超え>その他村人>村寄り村人>自分

占い破綻チェックアルゴリズム
確定○に●出しした人とか

CCOチェックアルゴリズム　●出された後にCOした場合、CCOカウント（ほぼ狼見）入れる
（COした対象が既に●を出されていた場合、非狼率に*0.1（ほぼ狼で見るということ）をする

占いアルゴリズム
対抗占い師の○を延々と占う（対抗占いの、結果○・生存・村人　の情報を取得）
・確定○を作る為
・グレーを狭める必要性が少ない為
・囲われていた時がめんどくさい為
・自分の○が吊られないようにする為

今出来てる事

エージェントごとのCO・投票先の分析
役職パターンの分析
指定された役職の合計値を入手する
生存情報を表示する


役職スライドは人外とみなす:心理的に、多分普通のプレイヤーは自役職はまともに作るだろう。エラーを検出したら人外寄りと判断して問題ないだろう
"""