* 開発優先度
    * 推理
        * 霊能結果の読み込み
        * 投票からの推理
            * 霊能非依存
            * 霊能依存
        * 占い師の推理
            * 占い●と霊能結果の一致チェック
        * 占い結果からの推理
    * 役職ごとの行動
        * 占い師・霊能者
            * 結果貼り
        * 人狼
            * 身内切り
        * 狂人
            * 未決定

前提条件
戦術などを人狼経験のみで判断し、その後は直感に頼る


基本仕様
戦術（役職の動きなどの構築。メイン処理も内蔵）-アルゴリズム（戦術処理に必要な処理（推理など）を行う）-推理（推理データが必要な時にアルゴリズムから呼び出される）
略してTAI。微笑みの国とは無関係


戦術

戦術のパターン
発言パターン（全役職共通）:結果貼りやCO以外は無発言
占いパターン:狼率の高いプレイヤーを占う
霊能パターン:初日、2日目CO。3日目から結果貼り
護衛パターン:占い1→占い護衛　占い2以上霊能1→霊能護衛　占い2以上霊能2→占い護衛

占い師パターン:初日CO、2日目から結果貼り
霊能者パターン:霊能パターンに準拠
人狼パターン:初日CO、2日目相方狼に人狼判定、3日目もう一人の狼に村人判定、その後狼率の低いプレイヤーを占う
狂人パターン:
村人パターン:未定義
狩人パターン:未定義

メイン処理
使う変数を定義する
代表的なもの一覧
・拡張テーブル（エージェントの役職、能力実行、本役職等を保存する）


アルゴリズム

戦術フォームで使用するもの一覧
推理データを使用しないもの
・占い破綻（矛盾した結果を出してないか）のチェック
・拡張テーブルの更新
・発言の取得（将来的に推理データを採用する予定）

推理データを使用するもの
・投票先や役職結果の分析及びエージェントの人狼・狂人率の算出
・投票先の決定
・占い先の決定


推理

推理箇所の基礎
推理に使う情報を、大きく2つに分ける
1　役職に依存しない情報（発言傾向。例えば「○○の発言する時は狼っぽい」など）
2　役職に依存する情報（占い結果など）

1は記録し、2は使用する時に計算する
そうする事で計算コストを抑えられる

人狼率の計算方法:非村人（以降NVと称す）率/非人狼（以降NWと称す）率
人外率の計算方法:NV/NW+非狂人率（以降NPと称す）


CCO

●貰いでCO:役職非依存で人狼寄り
対役職●出し:内訳ごとの予想人外率でどれほど正しいかどうかチェックをする（●先が役職COしている場合のみ）
（●出しした占い師が真だと仮定して、対抗の狂人/人狼率を分析する。真*人狼率　狂人and人狼*狂人率）
決め打ち要素:
例:
人狼の戦術
占い師パターンの推測

投票メタ

霊能結果非依存
2日目0票は狼目
対抗占いに○出す占い師は真目（狂人は●出しするだろうから）


霊能結果依存
占い→グレー●吊り及び霊結果●時に、●非投票者は人狼
狼投票者・狼被投票者は村目


占い
2日目●出し占いは真寄り（20%くらい）
狼占いの○はやや狼目で見る


推理
・統計データを取った所、確かに発言からの傾向は使えるかもしれないが、実装と時間が釣り合わない
・投票データは確かに参考になった